diff -urN ../VisualBoyAdvance-1.7.2/src/win32/VBA.cpp ./src/win32/VBA.cpp
--- ../VisualBoyAdvance-1.7.2/src/win32/VBA.cpp	2004-05-13 23:16:07 +0900
+++ ./src/win32/VBA.cpp	2006-08-06 21:40:35 +0900
@@ -1,6 +1,6 @@
 // VisualBoyAdvance - Nintendo Gameboy/GameboyAdvance (TM) emulator.
 // Copyright (C) 1999-2003 Forgotten
-// Copyright (C) 2004 Forgotten and the VBA development team
+// Copyright (C) 2005 Forgotten and the VBA development team
 
 // This program is free software; you can redistribute it and/or modify
 // it under the terms of the GNU General Public License as published by
@@ -19,13 +19,13 @@
 // VBA.cpp : Defines the class behaviors for the application.
 //
 #include "stdafx.h"
-#include <mmsystem.h>
 
 #include "AVIWrite.h"
 #include "LangSelect.h"
 #include "MainWnd.h"
 #include "Reg.h"
 #include "resource.h"
+#include "resource2.h"
 #include "skin.h"
 #include "WavWriter.h"
 #include "WinResUtil.h"
@@ -130,6 +130,23 @@
 extern "C" bool cpu_mmx;
 #endif
 
+namespace Sm60FPS
+{
+  float					K_fCpuSpeed = 98.0f;
+  float					K_fTargetFps = 60.0f * K_fCpuSpeed / 100;
+  float					K_fDT = 1000.0f / K_fTargetFps;
+
+  u32					dwTimeElapse;
+  u32					dwTime0;
+  u32					dwTime1;
+  u32					nFrameCnt;
+  float					fWantFPS;
+  float					fCurFPS;
+  bool					bLastSkip;
+  int					nCurSpeed;
+  int					bSaveMoreCPU;
+};
+
 void directXMessage(const char *msg)
 {
   systemMessage(IDS_DIRECTX_7_REQUIRED,
@@ -163,9 +180,11 @@
   filterType = 0;
   filterWidth = 0;
   filterHeight = 0;
+  fsAdapter = 0;
   fsWidth = 0;
   fsHeight = 0;
   fsColorDepth = 0;
+  fsFrequency = 0;
   fsForceChange = false;
   surfaceSizeX = 0;
   surfaceSizeY = 0;
@@ -183,7 +202,7 @@
   display = NULL;
   menu = NULL;
   popup = NULL;
-  cartridgeType = 0;
+  cartridgeType = IMAGE_GBA;
   soundInitialized = false;
   useBiosFile = false;
   skipBiosFile = false;
@@ -197,6 +216,7 @@
   winGbBorderOn = 0;
   winFlashSize = 0x10000;
   winRtcEnable = false;
+  winGenericflashcardEnable = false;
   winSaveType = 0;
   rewindMemory = NULL;
   rewindPos = 0;
@@ -246,6 +266,7 @@
   winPauseNextFrame = false;
   soundRecording = false;
   soundRecorder = NULL;
+  dsoundDisableHardwareAcceleration = true;
   sound = NULL;
   aviRecording = false;
   aviRecorder = NULL;
@@ -287,6 +308,15 @@
 {
   InterframeCleanup();
 
+  char winBuffer[2048];
+
+  GetModuleFileName(NULL, winBuffer, 2048);
+  char *p = strrchr(winBuffer, '\\');
+  if(p)
+    *p = 0;
+  
+  regInit(winBuffer);
+
   saveSettings();
 
   if(moviePlaying) {
@@ -350,7 +380,6 @@
 // The one and only VBA object
 
 VBA theApp;
-#include <afxdisp.h>
 /////////////////////////////////////////////////////////////////////////////
 // VBA initialization
 
@@ -407,17 +436,13 @@
 
 BOOL VBA::InitInstance()
 {
-  AfxEnableControlContainer();
-  // Standard initialization
-  // If you are not using these features and wish to reduce the size
-  //  of your final executable, you should remove from the following
-  //  the specific initialization routines you do not need.
-
+#if _MSC_VER < 1400
 #ifdef _AFXDLL
   Enable3dControls();      // Call this when using MFC in a shared DLL
 #else
   Enable3dControlsStatic();  // Call this when linking to MFC statically
 #endif
+#endif
 
   SetRegistryKey(_T("VBA"));
 
@@ -504,6 +529,7 @@
   return TRUE;
 }
 
+
 void VBA::adjustDestRect()
 {
   POINT point;
@@ -570,6 +596,7 @@
   }
 }
 
+
 void VBA::updateIFB()
 {
   if(systemColorDepth == 16) {
@@ -810,6 +837,9 @@
     }
   }
 
+  if (Sm60FPS_CanSkipFrame())
+	  return;
+
   if(theApp.aviRecording && !theApp.painting) {
     int width = 240;
     int height = 160;
@@ -855,16 +885,15 @@
     delete bmp;
   }
 
-  if(theApp.ifbFunction) {
-    if(systemColorDepth == 16)
-      theApp.ifbFunction(pix+theApp.filterWidth*2+4, theApp.filterWidth*2+4,
-                         theApp.filterWidth, theApp.filterHeight);
-    else
-      theApp.ifbFunction(pix+theApp.filterWidth*4+4, theApp.filterWidth*4+4,
-                         theApp.filterWidth, theApp.filterHeight);
+  if( theApp.ifbFunction ) {
+	  theApp.ifbFunction( pix + (theApp.filterWidth * (systemColorDepth>>3)) + 4,
+		  (theApp.filterWidth * (systemColorDepth>>3)) + 4,
+		  theApp.filterWidth, theApp.filterHeight );
   }
 
   theApp.display->render();
+
+  Sm60FPS_Sleep();
 }
 
 void systemScreenCapture(int captureNumber)
@@ -875,7 +904,7 @@
 
 u32 systemGetClock()
 {
-  return timeGetTime();
+  return GetTickCount();
 }
 
 void systemMessage(int number, const char *defaultMsg, ...)
@@ -932,34 +961,18 @@
 void system10Frames(int rate)
 {
   u32 time = systemGetClock();  
-  if(!theApp.wasPaused && theApp.autoFrameSkip && !theApp.throttle) {
-    u32 diff = time - theApp.autoFrameSkipLastTime;
-    int speed = 100;
 
-    if(diff)
-      speed = (1000000/rate)/diff;
-    
-    if(speed >= 98) {
-      theApp.frameskipadjust++;
+  if (theApp.autoFrameSkip)
+  {
+    u32 diff = time - theApp.autoFrameSkipLastTime;
+	Sm60FPS::nCurSpeed = 100;
 
-      if(theApp.frameskipadjust >= 3) {
-        theApp.frameskipadjust=0;
-        if(systemFrameSkip > 0)
-          systemFrameSkip--;
-      }
-    } else {
-      if(speed  < 80)
-        theApp.frameskipadjust -= (90 - speed)/5;
-      else if(systemFrameSkip < 9)
-        theApp.frameskipadjust--;
-
-      if(theApp.frameskipadjust <= -2) {
-        theApp.frameskipadjust += 2;
-        if(systemFrameSkip < 9)
-          systemFrameSkip++;
-      }
-    }    
+    if (diff)
+		Sm60FPS::nCurSpeed = (1000000/rate)/diff;
   }
+
+
+
   if(!theApp.wasPaused && theApp.throttle) {
     if(!speedup) {
       u32 diff = time - theApp.throttleLastTime;
@@ -1074,7 +1087,7 @@
 
 void systemGbBorderOn()
 {
-  if(emulating && theApp.cartridgeType == 1 && gbBorderOn) {
+  if(emulating && theApp.cartridgeType == IMAGE_GB && gbBorderOn) {
     theApp.updateWindowSize(theApp.videoOption);
   }
 }
@@ -1170,9 +1183,9 @@
   
   winSetLanguageOption(languageOption, true);
   
-  frameSkip = regQueryDwordValue("frameSkip", 2);
+  frameSkip = regQueryDwordValue("frameSkip", 0);
   if(frameSkip < 0 || frameSkip > 9)
-    frameSkip = 2;
+    frameSkip = 0;
 
   gbFrameSkip = regQueryDwordValue("gbFrameSkip", 0);
   if(gbFrameSkip < 0 || gbFrameSkip > 9)
@@ -1184,8 +1197,7 @@
   synchronize = regQueryDwordValue("synchronize", 1) ? true : false;
   fullScreenStretch = regQueryDwordValue("stretch", 0) ? true : false;
 
-  videoOption = regQueryDwordValue("video", 0);
-
+  videoOption = regQueryDwordValue("video", 1);
   if(videoOption < 0 || videoOption > VIDEO_OTHER)
     videoOption = 0;
 
@@ -1202,9 +1214,11 @@
   else
     pVideoDriverGUID = &videoDriverGUID;
 
+  fsAdapter = regQueryDwordValue("fsAdapter", 0);
   fsWidth = regQueryDwordValue("fsWidth", 0);
   fsHeight = regQueryDwordValue("fsHeight", 0);
   fsColorDepth = regQueryDwordValue("fsColorDepth", 0);
+  fsFrequency = regQueryDwordValue("fsFrequency", 0);
 
   if(videoOption == VIDEO_OTHER) {
     if(fsWidth < 0 || fsWidth > 4095 || fsHeight < 0 || fsHeight > 4095)
@@ -1214,7 +1228,6 @@
   }
 
   renderMethod = (DISPLAY_TYPE)regQueryDwordValue("renderMethod", DIRECT_DRAW);
-
   if(renderMethod < GDI || renderMethod > OPENGL)
     renderMethod = DIRECT_DRAW;
   
@@ -1242,7 +1255,7 @@
 
   soundOffFlag = (regQueryDwordValue("soundOff", 0)) ? true : false;
 
-  soundQuality = regQueryDwordValue("soundQuality", 2);
+  soundQuality = regQueryDwordValue("soundQuality", 1);
 
   soundEcho = regQueryDwordValue("soundEcho", 0) ? true : false;
 
@@ -1255,15 +1268,17 @@
     soundVolume = 0;
 
   ddrawEmulationOnly = regQueryDwordValue("ddrawEmulationOnly", false) ? true : false;
-  ddrawUseVideoMemory = regQueryDwordValue("ddrawUseVideoMemory", false) ? true : false;
-  tripleBuffering = regQueryDwordValue("tripleBuffering", true) ? true : false;
+  ddrawUseVideoMemory = regQueryDwordValue("ddrawUseVideoMemory", true) ? true : false;
+  tripleBuffering = regQueryDwordValue("tripleBuffering", false) ? true : false;
 
-  d3dFilter = regQueryDwordValue("d3dFilter", 0);
+  d3dFilter = regQueryDwordValue("d3dFilter", 1);
   if(d3dFilter < 0 || d3dFilter > 1)
-    d3dFilter = 0;
-  glFilter = regQueryDwordValue("glFilter", 0);
+    d3dFilter = 1;
+
+  glFilter = regQueryDwordValue("glFilter", 1);
   if(glFilter < 0 || glFilter > 1)
-    glFilter = 0;
+    glFilter = 1;
+
   glType = regQueryDwordValue("glType", 0);
   if(glType < 0 || glType > 1)
     glType = 0;
@@ -1272,7 +1287,7 @@
   if(filterType < 0 || filterType > 13)
     filterType = 0;
 
-  disableMMX = regQueryDwordValue("disableMMX", 0) ? true: false;
+  disableMMX = regQueryDwordValue("disableMMX", false) ? true: false;
 
   disableStatusMessage = regQueryDwordValue("disableStatus", 0) ? true : false;
 
@@ -1310,9 +1325,6 @@
   if(winSaveType < 0 || winSaveType > 5)
     winSaveType = 0;
   
-  cpuEnhancedDetection = regQueryDwordValue("enhancedDetection", 1) ? true :
-    false;
-
   ifbType = regQueryDwordValue("ifbType", 0);
   if(ifbType < 0 || ifbType > 2)
     ifbType = 0;
@@ -1320,6 +1332,7 @@
   winFlashSize = regQueryDwordValue("flashSize", 0x10000);
   if(winFlashSize != 0x10000 && winFlashSize != 0x20000)
     winFlashSize = 0x10000;
+  flashSize = winFlashSize;
 
   agbPrintEnable(regQueryDwordValue("agbPrint", 0) ? true : false);
 
@@ -1407,6 +1420,15 @@
   throttle = regQueryDwordValue("throttle", 0);
   if(throttle < 5 || throttle > 1000)
     throttle = 0;
+
+  if (autoFrameSkip)
+  {
+	  throttle = 0;
+	  frameSkip = 0;
+	  systemFrameSkip = 0;
+  }
+
+  Sm60FPS::bSaveMoreCPU = regQueryDwordValue("saveMoreCPU", 0);
 }
 
 void VBA::updateFrameSkip()
@@ -1442,28 +1464,25 @@
     value = VIDEO_320x240;
     fsWidth = 320;
     fsHeight = 240;
-    fsColorDepth = 16;
+    fsColorDepth = 32;
     break;
   case ID_OPTIONS_VIDEO_FULLSCREEN640X480:
     value = VIDEO_640x480;
     fsWidth = 640;
     fsHeight = 480;
-    fsColorDepth = 16;
+    fsColorDepth = 32;
     break;
   case ID_OPTIONS_VIDEO_FULLSCREEN800X600:
     value = VIDEO_800x600;
     fsWidth = 800;
     fsHeight = 600;
-    fsColorDepth = 16;
+    fsColorDepth = 32;
     break;
   case ID_OPTIONS_VIDEO_FULLSCREEN:
     value = VIDEO_OTHER;
     break;
   }
 
-  if(videoOption == value && value != VIDEO_OTHER)
-    return;
-
   updateWindowSize(value);
 }
 
@@ -1474,15 +1493,18 @@
   HINSTANCE hinstDll;
   DWORD dwVersion = 0;
   
-  hinstDll = AfxLoadLibrary("USER32.DLL");
+#ifdef _AFXDLL
+  hinstDll = AfxLoadLibrary("user32.dll");
+#else
+  hinstDll = LoadLibrary( _T("user32.dll") );
+#endif
   
   if(hinstDll) {
-    GETMENUBARINFO func = (GETMENUBARINFO)GetProcAddress(hinstDll,
-                                                         "GetMenuBarInfo");
+	  GETMENUBARINFO func = (GETMENUBARINFO)GetProcAddress(hinstDll, "GetMenuBarInfo");
 
     if(func) {
       MENUBARINFO info;
-      info.cbSize = sizeof(info);
+      info.cbSize = sizeof(MENUBARINFO);
       
       func(AfxGetMainWnd()->GetSafeHwnd(), OBJID_MENU, 0, &info);
       
@@ -1499,7 +1521,11 @@
                                         SWP_NOMOVE | SWP_SHOWWINDOW);
       }
     }
-    AfxFreeLibrary(hinstDll);
+#ifdef _AFXDLL
+    AfxFreeLibrary( hinstDll );
+#else
+    FreeLibrary( hinstDll );
+#endif
   }
 }
 
@@ -1561,7 +1587,7 @@
 
   videoOption = value;
   
-  if(cartridgeType == 1) {
+  if(cartridgeType == IMAGE_GB) {
     if(gbBorderOn) {
       sizeX = 256;
       sizeY = 224;
@@ -1660,6 +1686,9 @@
   updateIFB();  
   updateFilter();
   
+  if(display)
+    display->resize(theApp.dest.right-theApp.dest.left, theApp.dest.bottom-theApp.dest.top);
+  
   m_pMainWnd->RedrawWindow(NULL,NULL,RDW_INVALIDATE|RDW_ERASE|RDW_ALLCHILDREN);  
 }
 
@@ -1670,26 +1699,37 @@
 
 bool VBA::updateRenderMethod(bool force)
 {
-  bool res = updateRenderMethod0(force);
-  
-  while(!res && renderMethod > 0) {
-    if(renderMethod == OPENGL)
-      renderMethod = DIRECT_3D;
-    else if(renderMethod == DIRECT_3D)
-      renderMethod = DIRECT_DRAW;
-    else if(renderMethod == DIRECT_DRAW) {
-      if(videoOption > VIDEO_4X) {
-        videoOption = VIDEO_2X;
-        force = true;
-      } else
-        renderMethod = GDI;
-    }
-                                    
-    res = updateRenderMethod(force);
-  }
-  return res;  
+	Sm60FPS_Init();
+	bool res = updateRenderMethod0(force);
+
+	while(!res && renderMethod > 0) {
+		if( fsAdapter > 0 ) {
+			fsAdapter = 0;
+		} else {
+			if( videoOption > VIDEO_4X ) {
+				videoOption = VIDEO_1X;
+				force = true;
+			} else {
+				if(renderMethod == OPENGL) {
+					renderMethod = DIRECT_3D;
+				} else {
+					if(renderMethod == DIRECT_3D) {
+						renderMethod = DIRECT_DRAW;
+					} else {
+						if(renderMethod == DIRECT_DRAW) {
+							renderMethod = GDI;
+						}
+					}
+				}
+			}
+		}
+		res = updateRenderMethod(force);
+	}
+
+	return res;
 }
 
+
 bool VBA::updateRenderMethod0(bool force)
 {
   bool initInput = false;
@@ -1721,17 +1761,19 @@
   if(display == NULL) {
     switch(renderMethod) {
     case GDI:
-      display = newGDIDisplay();
-      break;
+		display = newGDIDisplay();
+		break;
     case DIRECT_DRAW:
-      display = newDirectDrawDisplay();
-      break;
+		pVideoDriverGUID = NULL;
+		ZeroMemory( &videoDriverGUID, sizeof( GUID ) );
+		display = newDirectDrawDisplay();
+		break;
     case DIRECT_3D:
-      display = newDirect3DDisplay();
-      break;
-    case OPENGL:
-      display = newOpenGLDisplay();
-      break;
+		display = newDirect3DDisplay();
+		break;
+	case OPENGL:
+		display = newOpenGLDisplay();
+		break;
     }
     
     if(display->initialize()) {
@@ -1762,14 +1804,17 @@
   return true;
 }
 
+
 void VBA::winCheckFullscreen()
 {
-  if(videoOption > VIDEO_4X && tripleBuffering) {
-    if(display)
-      display->checkFullScreen();
-  }
+	if(videoOption > VIDEO_4X && tripleBuffering) {
+		if(display) {
+			display->checkFullScreen();
+		}
+	}
 }
 
+
 void VBA::shutdownDisplay()
 {
   if(display != NULL) {
@@ -1788,6 +1833,7 @@
 
 void VBA::winUpdateSkin()
 {
+#ifndef NOSKINS
   skinButtons = 0;
   if(skin) {
     delete skin;
@@ -1809,6 +1855,7 @@
     adjustDestRect();
     updateMenuBar();
   }
+#endif
 }
 
 void VBA::updatePriority()
@@ -1896,7 +1943,11 @@
         }
         AfxSetResourceHandle(l);
         if(languageModule != NULL)
-          AfxFreeLibrary(languageModule);
+#ifdef _AFXDLL
+          AfxFreeLibrary( languageModule );
+#else
+          FreeLibrary( languageModule );
+#endif
         languageModule = l;
       } else {
         systemMessage(IDS_FAILED_TO_GET_LOCINFO,
@@ -1907,7 +1958,11 @@
     break;
   case 1:
     if(languageModule != NULL)
-      AfxFreeLibrary(languageModule);
+#ifdef _AFXDLL
+      AfxFreeLibrary( languageModule );
+#else
+      FreeLibrary( languageModule );
+#endif
     languageModule = NULL;
     AfxSetResourceHandle(AfxGetInstanceHandle());
     break;
@@ -1925,7 +1980,13 @@
           }
           AfxSetResourceHandle(l);
           if(languageModule != NULL)
-            AfxFreeLibrary(languageModule);
+		  {
+#ifdef _AFXDLL
+            AfxFreeLibrary( languageModule );
+#else
+            FreeLibrary( languageModule );
+#endif
+		  }
           languageModule = l;
         }
       } else {
@@ -1954,9 +2015,13 @@
 {
   CString buffer;
   
-  buffer.Format("vba_%s.dll", name);
+  buffer.Format( _T("vba_%s.dll"), name);
 
-  HINSTANCE l = AfxLoadLibrary(buffer);
+#ifdef _AFXDLL
+  HINSTANCE l = AfxLoadLibrary( buffer );
+#else
+  HMODULE l = LoadLibrary( buffer );
+#endif
   
   if(l == NULL) {
     if(strlen(name) == 3) {
@@ -1966,7 +2031,11 @@
       buffer2[2] = 0;
       buffer.Format("vba_%s.dll", buffer2);
 
-      return AfxLoadLibrary(buffer);
+#ifdef _AFXDLL
+	  return AfxLoadLibrary( buffer );
+#else
+	  return LoadLibrary( buffer );
+#endif
     }
   }
   return l;
@@ -2065,9 +2134,11 @@
   }
 
 
+  regSetDwordValue("fsAdapter", fsAdapter);
   regSetDwordValue("fsWidth", fsWidth);
   regSetDwordValue("fsHeight", fsHeight);
   regSetDwordValue("fsColorDepth", fsColorDepth);
+  regSetDwordValue("fsFrequency", fsFrequency);
 
   regSetDwordValue("renderMethod", renderMethod);
 
@@ -2131,8 +2202,6 @@
   
   regSetDwordValue("saveType", winSaveType);
   
-  regSetDwordValue("enhancedDetection", cpuEnhancedDetection);
-
   regSetDwordValue("ifbType", ifbType);
 
   regSetDwordValue("flashSize", winFlashSize);
@@ -2174,6 +2243,8 @@
   regSetDwordValue("cheatsEnabled", cheatsEnabled);
   regSetDwordValue("fsMaxScale", fsMaxScale);
   regSetDwordValue("throttle", throttle);
+
+  regSetDwordValue("saveMoreCPU", Sm60FPS::bSaveMoreCPU);
 }
 
 void winSignal(int, int)
@@ -2201,3 +2272,73 @@
     toolsLog(str);
   }  
 }
+
+
+void Sm60FPS_Init()
+{
+	Sm60FPS::dwTimeElapse = 0;
+	Sm60FPS::fWantFPS = 60.f;
+	Sm60FPS::fCurFPS = 0.f;
+	Sm60FPS::nFrameCnt = 0;
+	Sm60FPS::bLastSkip = false;
+	Sm60FPS::nCurSpeed = 100;
+}
+
+
+bool Sm60FPS_CanSkipFrame()
+{
+  if( theApp.autoFrameSkip ) {
+	  if( Sm60FPS::nFrameCnt == 0 ) {
+		  Sm60FPS::nFrameCnt = 0;
+		  Sm60FPS::dwTimeElapse = 0;
+		  Sm60FPS::dwTime0 = timeGetTime();
+	  } else {
+		  if( Sm60FPS::nFrameCnt >= 10 ) {
+			  Sm60FPS::nFrameCnt = 0;
+			  Sm60FPS::dwTimeElapse = 0;
+
+			  if( Sm60FPS::nCurSpeed > Sm60FPS::K_fCpuSpeed ) {
+				  Sm60FPS::fWantFPS += 1;
+				  if( Sm60FPS::fWantFPS > Sm60FPS::K_fTargetFps ){
+					  Sm60FPS::fWantFPS = Sm60FPS::K_fTargetFps;
+				  }
+			  } else {
+				  if( Sm60FPS::nCurSpeed < (Sm60FPS::K_fCpuSpeed - 5) ) {
+					  Sm60FPS::fWantFPS -= 1;
+					  if( Sm60FPS::fWantFPS < 30.f ) {
+						  Sm60FPS::fWantFPS = 30.f;
+					  }
+				  }
+			  }
+		  } else { // between frame 1-10
+			  Sm60FPS::dwTime1 = timeGetTime();
+			  Sm60FPS::dwTimeElapse += (Sm60FPS::dwTime1 - Sm60FPS::dwTime0);
+			  Sm60FPS::dwTime0 = Sm60FPS::dwTime1;
+			  if( !Sm60FPS::bLastSkip &&
+				  ( (Sm60FPS::fWantFPS < Sm60FPS::K_fTargetFps) || Sm60FPS::bSaveMoreCPU) ) {
+					  Sm60FPS::fCurFPS = (float)Sm60FPS::nFrameCnt * 1000 / Sm60FPS::dwTimeElapse;
+					  if( (Sm60FPS::fCurFPS < Sm60FPS::K_fTargetFps) || Sm60FPS::bSaveMoreCPU ) {
+						  Sm60FPS::bLastSkip = true;
+						  Sm60FPS::nFrameCnt++;
+						  return true;
+					  }
+			  }
+		  }
+	  }
+	  Sm60FPS::bLastSkip = false;
+	  Sm60FPS::nFrameCnt++;
+  }	
+  return false;
+}
+
+
+void Sm60FPS_Sleep()
+{
+	if( theApp.autoFrameSkip ) {
+		u32 dwTimePass = Sm60FPS::dwTimeElapse + (timeGetTime() - Sm60FPS::dwTime0);
+		u32 dwTimeShould = (u32)(Sm60FPS::nFrameCnt * Sm60FPS::K_fDT);
+		if( dwTimeShould > dwTimePass ) {
+			Sleep(dwTimeShould - dwTimePass);
+		}
+	}
+}
diff -urN ../VisualBoyAdvance-1.7.2/src/win32/VBA.h ./src/win32/VBA.h
--- ../VisualBoyAdvance-1.7.2/src/win32/VBA.h	2004-05-13 22:32:30 +0900
+++ ./src/win32/VBA.h	2006-08-06 21:40:35 +0900
@@ -1,7 +1,7 @@
 // -*- C++ -*-
 // VisualBoyAdvance - Nintendo Gameboy/GameboyAdvance (TM) emulator.
 // Copyright (C) 1999-2003 Forgotten
-// Copyright (C) 2004 Forgotten and the VBA development team
+// Copyright (C) 2005 Forgotten and the VBA development team
 
 // This program is free software; you can redistribute it and/or modify
 // it under the terms of the GNU General Public License as published by
@@ -20,26 +20,23 @@
 // VBA.h : main header file for the VBA application
 //
 
-#if !defined(AFX_VBA_H__57514A10_49F9_4B83_A928_0D8A4A7306A3__INCLUDED_)
-#define AFX_VBA_H__57514A10_49F9_4B83_A928_0D8A4A7306A3__INCLUDED_
-
-#if _MSC_VER > 1000
 #pragma once
-#endif // _MSC_VER > 1000
 
 #ifndef __AFXWIN_H__
 #error include 'stdafx.h' before including this file for PCH
 #endif
 
-#include <afxtempl.h>
+#include "stdafx.h"
+#include "resource.h"
+//#include <afxtempl.h>
 
 #include "AcceleratorManager.h"
-#include "resource.h"       // main symbols
 #include "Display.h"
 #include "Input.h"
 #include "IUpdate.h"
 #include "Sound.h"
 #include "../System.h"
+#include "../Util.h"
 
 /////////////////////////////////////////////////////////////////////////////
 // VBA:
@@ -47,8 +44,14 @@
 //
 
 enum {
-  VIDEO_1X, VIDEO_2X, VIDEO_3X, VIDEO_4X,
-  VIDEO_320x240, VIDEO_640x480, VIDEO_800x600, VIDEO_OTHER
+	VIDEO_1X,
+	VIDEO_2X,
+	VIDEO_3X,
+	VIDEO_4X,
+	VIDEO_320x240,
+	VIDEO_640x480,
+	VIDEO_800x600,
+	VIDEO_OTHER
 };
 
 #define REWIND_SIZE 400000
@@ -74,9 +77,11 @@
   int filterType;
   int filterWidth;
   int filterHeight;
+  int fsAdapter;
   int fsWidth;
   int fsHeight;
   int fsColorDepth;
+  int fsFrequency;
   bool fsForceChange;
   int sizeX;
   int sizeY;
@@ -94,7 +99,7 @@
   u8 *delta[257*244*4];
   bool menuToggle;
   IDisplay *display;
-  int cartridgeType;
+  IMAGE_TYPE cartridgeType;
   bool soundInitialized;
   bool useBiosFile;
   bool skipBiosFile;
@@ -110,6 +115,7 @@
   int winGbBorderOn;
   int winFlashSize;
   bool winRtcEnable;
+  bool winGenericflashcardEnable;
   int winSaveType;
   char *rewindMemory;
   int rewindPos;
@@ -150,7 +156,7 @@
   bool disableMMX;
   int languageOption;
   CString languageName;
-  HINSTANCE languageModule;
+  HMODULE languageModule;
   int renderedFrames;
   Input *input;
   int joypadDefault;
@@ -160,6 +166,7 @@
   bool soundRecording;
   WavWriter *soundRecorder;
   CString soundRecordName;
+  bool dsoundDisableHardwareAcceleration;
   ISound *sound;
   bool aviRecording;
   AVIWrite *aviRecorder;
@@ -225,10 +232,10 @@
   void saveSettings();
   void movieReadNext();
   bool initInput();
-  HINSTANCE winLoadLanguage(const char *name);
+  HMODULE winLoadLanguage(const char *name);
   void winSetLanguageOption(int option, bool force);
-  bool detectMMX();
 #ifdef MMX
+  bool detectMMX();
 #endif
   void updatePriority();
   void winUpdateSkin();
@@ -252,14 +259,8 @@
     };
 
     extern VBA theApp;
+	extern int emulating;
 
 #ifdef MMX
     extern "C" bool cpu_mmx;
-#endif
-
-    /////////////////////////////////////////////////////////////////////////////
-
-    //{{AFX_INSERT_LOCATION}}
-    // Microsoft Visual C++ will insert additional declarations immediately before the previous line.
-
-#endif // !defined(AFX_VBA_H__57514A10_49F9_4B83_A928_0D8A4A7306A3__INCLUDED_)
+#endif
\ No newline at end of file
diff -urN ../VisualBoyAdvance-1.7.2/src/win32/VideoMode.cpp ./src/win32/VideoMode.cpp
--- ../VisualBoyAdvance-1.7.2/src/win32/VideoMode.cpp	2004-05-13 23:15:52 +0900
+++ ./src/win32/VideoMode.cpp	2006-07-26 22:02:44 +0900
@@ -100,22 +100,31 @@
 
 static HRESULT WINAPI addVideoMode(LPDDSURFACEDESC2 surf, LPVOID lpContext)
 {
-  HWND h = (HWND)lpContext;
-  char buffer[50];
-  
-  switch(surf->ddpfPixelFormat.dwRGBBitCount) {
-  case 16:
-  case 24:
-  case 32:
-    if(surf->dwWidth >= 640 && surf->dwHeight >= 480) {
-      sprintf(buffer, "%4dx%4dx%2d", surf->dwWidth, surf->dwHeight,
-              surf->ddpfPixelFormat.dwRGBBitCount);
-      int pos = ::SendMessage(h, LB_ADDSTRING, 0, (LPARAM)buffer);
-      ::SendMessage(h, LB_SETITEMDATA, pos,
-                    (surf->ddpfPixelFormat.dwRGBBitCount << 24) |
-                    ((surf->dwWidth & 4095) << 12) |
-                    (surf->dwHeight & 4095));
-    }
+	HWND h = (HWND)lpContext;
+	char buffer[50];
+	
+	switch( surf->ddpfPixelFormat.dwRGBBitCount )
+	{
+	case 16:
+	case 24:
+	case 32:
+		sprintf(
+			buffer,
+			_T("%4dx%4dx%2d"),
+			surf->dwWidth,
+			surf->dwHeight,
+			surf->ddpfPixelFormat.dwRGBBitCount
+			);
+		WPARAM pos = ::SendMessage( h, LB_ADDSTRING, 0, (LPARAM)buffer );
+		::SendMessage(
+			h,
+			LB_SETITEMDATA,
+			pos,
+			(surf->ddpfPixelFormat.dwRGBBitCount << 24) |
+			((surf->dwWidth & 4095) << 12) |
+			(surf->dwHeight & 4095)
+			);
+    break;
   }
 
   return DDENUMRET_OK;
@@ -123,7 +132,11 @@
 
 int winVideoModeSelect(CWnd *pWnd, GUID **guid)
 {
+#ifdef _AFXDLL
   HINSTANCE h = AfxLoadLibrary("ddraw.dll");
+#else
+  HMODULE h = LoadLibrary( _T("ddraw.dll") );
+#endif
  
   // If ddraw.dll doesn't exist in the search path,
   // then DirectX probably isn't installed, so fail.
@@ -180,12 +193,14 @@
   if(gDriverCnt > 1) {
     VideoDriverSelect d(pWnd);
 
-    selected = d.DoModal();
+    INT_PTR selected = d.DoModal();
 
     if(selected == -1) {
-      // If the library was loaded by calling LoadLibrary(),
-      // then you must use FreeLibrary() to let go of it.
-      AfxFreeLibrary(h);
+#ifdef _AFXDLL
+      AfxFreeLibrary( h );
+#else
+      FreeLibrary( h );
+#endif
       
       return -1;
     }
@@ -203,19 +218,27 @@
                                  NULL);
     if(hret != DD_OK) {
       systemMessage(0, "Error during DirectDrawCreateEx: %08x", hret);
-      AfxFreeLibrary(h);
+#ifdef _AFXDLL
+      AfxFreeLibrary( h );
+#else
+      FreeLibrary( h );
+#endif
       return -1;
     }
   } else {
     // should not happen....
     systemMessage(0, "Error getting DirectDrawCreateEx");
-    AfxFreeLibrary(h);
+#ifdef _AFXDLL
+    AfxFreeLibrary( h );
+#else
+    FreeLibrary( h );
+#endif
     return -1;
   }  
   
   VideoMode dlg(ddraw, pWnd);
 
-  int res = dlg.DoModal();
+  INT_PTR res = dlg.DoModal();
 
   if(res != -1) {
     *guid = Drivers[selected].pGUID;
@@ -225,9 +248,13 @@
 
   // If the library was loaded by calling LoadLibrary(),
   // then you must use FreeLibrary() to let go of it.
-  AfxFreeLibrary(h);
+#ifdef _AFXDLL
+  AfxFreeLibrary( h );
+#else
+  FreeLibrary( h );
+#endif
 
-  return res;
+  return (int)res;
 }
 
 /////////////////////////////////////////////////////////////////////////////
@@ -278,12 +305,12 @@
 
 void VideoMode::OnOk() 
 {
-  int cur = m_modes.GetCurSel();
+  DWORD_PTR cur = m_modes.GetCurSel();
 
   if(cur != -1) {
-    cur = m_modes.GetItemData(cur);
+    cur = m_modes.GetItemData((int)cur);
   }
-  EndDialog(cur);
+  EndDialog((int)cur);
 }
 
 BOOL VideoMode::OnInitDialog() 
@@ -291,8 +318,11 @@
   CDialog::OnInitDialog();
   
   // check for available fullscreen modes
-  pDirectDraw->EnumDisplayModes(DDEDM_STANDARDVGAMODES, NULL, m_modes.m_hWnd,
-                                addVideoMode);
+  pDirectDraw->EnumDisplayModes(
+	  DDEDM_STANDARDVGAMODES,
+	  NULL,
+	  m_modes.m_hWnd,
+	  addVideoMode);
   
   GetDlgItem(ID_OK)->EnableWindow(FALSE);      
   CenterWindow();
diff -urN ../VisualBoyAdvance-1.7.2/src/win32/ZoomControl.h ./src/win32/ZoomControl.h
--- ../VisualBoyAdvance-1.7.2/src/win32/ZoomControl.h	2004-05-13 22:30:22 +0900
+++ ./src/win32/ZoomControl.h	2006-05-27 23:47:33 +0900
@@ -20,7 +20,7 @@
 #if !defined(AFX_ZOOMCONTROL_H__BC193230_D2D6_4240_93AE_28C2EF2C641A__INCLUDED_)
 #define AFX_ZOOMCONTROL_H__BC193230_D2D6_4240_93AE_28C2EF2C641A__INCLUDED_
 
-#include "..\System.h"  // Added by ClassView
+#include "../System.h"  // Added by ClassView
 #if _MSC_VER > 1000
 #pragma once
 #endif // _MSC_VER > 1000
diff -urN ../VisualBoyAdvance-1.7.2/src/win32/display.cpp ./src/win32/display.cpp
--- ../VisualBoyAdvance-1.7.2/src/win32/display.cpp	1970-01-01 09:00:00 +0900
+++ ./src/win32/display.cpp	2006-08-01 00:51:01 +0900
@@ -0,0 +1,123 @@
+// VisualBoyAdvance - Nintendo Gameboy/GameboyAdvance (TM) emulator.
+// Copyright (C) 1999-2003 Forgotten
+// Copyright (C) 2004 Forgotten and the VBA development team
+
+// This program is free software; you can redistribute it and/or modify
+// it under the terms of the GNU General Public License as published by
+// the Free Software Foundation; either version 2, or(at your option)
+// any later version.
+//
+// This program is distributed in the hope that it will be useful,
+// but WITHOUT ANY WARRANTY; without even the implied warranty of
+// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+// GNU General Public License for more details.
+//
+// You should have received a copy of the GNU General Public License
+// along with this program; if not, write to the Free Software Foundation,
+// Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
+
+#include "stdafx.h"
+#include "Display.h"
+
+void copyImage( void *source, void *destination, unsigned int width, unsigned int height, unsigned int destinationPitch, unsigned int colorDepth )
+{
+#ifdef ASM
+
+	// Copy the image at [source] to the locked Direct3D texture
+	__asm
+	{
+		mov eax, width            ; Initialize
+		mov ebx, height           ;
+		mov edi, destination      ;
+		mov edx, destinationPitch ;
+
+		cmp colorDepth, 16       ; Check colorDepth==16bit
+		jnz gbaOtherColor        ;
+		sub edx, eax             ;
+		sub edx, eax             ;
+		mov esi, source          ;
+		lea esi,[esi+2*eax+4]    ;
+		shr eax, 1               ;
+gbaLoop16bit:
+		mov ecx, eax     ;
+		rep movsd        ;
+		add esi, 4       ;
+		add edi, edx     ;
+		dec ebx          ;
+		jnz gbaLoop16bit ;
+		jmp gbaLoopEnd   ;
+gbaOtherColor:
+		cmp colorDepth, 32     ; Check colorDepth==32bit
+		jnz gbaOtherColor2     ;
+
+		lea esi, [eax*4]       ;
+		sub edx, esi           ;
+		mov esi, source        ;
+		lea esi, [esi+4*eax+4] ;
+gbaLoop32bit:
+		mov ecx, eax     ;
+		rep movsd        ; ECX times: Move DWORD at [ESI] to [EDI] | ESI++ EDI++
+		add esi, 4       ;
+		add edi, edx     ;
+		dec ebx          ;
+		jnz gbaLoop32bit ;
+		jmp gbaLoopEnd   ;
+gbaOtherColor2:
+		lea eax, [eax+2*eax] ; Works like colorDepth==24bit
+		sub edx, eax         ;
+gbaLoop24bit:
+		mov ecx, eax     ;
+		shr ecx, 2       ;
+		rep movsd        ;
+		add edi, edx     ;
+		dec ebx          ;
+		jnz gbaLoop24bit ;
+gbaLoopEnd:
+	}
+
+#else // #ifdef ASM
+
+	// optimized C version
+	register unsigned int lineSize;
+	register unsigned char *src, *dst;
+	switch(colorDepth)
+	{
+	case 16:
+		lineSize = width<<1;
+		src = ((unsigned char*)source) + lineSize + 4;
+		dst = (unsigned char*)destination;
+		do {
+			MoveMemory( dst, src, lineSize );
+				src+=lineSize;
+				dst+=lineSize;
+			src += 2;
+			dst += (destinationPitch - lineSize);
+		} while ( --height);
+		break;
+	case 32:
+		lineSize = width<<2;
+		src = ((unsigned char*)source) + lineSize + 4;
+		dst = (unsigned char*)destination;
+		do {
+			MoveMemory( dst, src, lineSize );
+				src+=lineSize;
+				dst+=lineSize;
+			src += 4;
+			dst += (destinationPitch - lineSize);
+		} while ( --height);
+		break;
+	}
+
+	// very compatible but slow C version
+	//unsigned int nBytesPerPixel = colorDepth>>3;
+	//unsigned int i, x, y, srcPitch = (width+1) * nBytesPerPixel;
+	//unsigned char * src = ((unsigned char*)source)+srcPitch;
+	//unsigned char * dst = (unsigned char*)destination;
+	//for (y=0;y<height;y++) //Width
+		//for (x=0;x<width;x++) //Height
+			//for (i=0;i<nBytesPerPixel;i++) //Byte# Of Pixel
+				//*(dst+i+(x*nBytesPerPixel)+(y*destinationPitch)) = *(src+i+(x*nBytesPerPixel)+(y*srcPitch));
+
+#endif
+}
+
